require "defines"
require "util"
--when player exits the vehicle if he's walking, he gets teleported 3 tiles in direction he's walking

--will be done by tracking the related event and enabling on_tick handler to detect where the player is moving
--and teleport him with help of util functions

script.on_init(
function()
    global.players={}--here we'll store players that should get teleported, along with the tick it should happen
    global.active=false--this one controls on_tick handler
end)
--game.on_load(
--function()
    --global.players=global.players or {}--here we'll store players that should get teleported, along with the tick it should happen
    --global.active=global.active or false--this one controls on_tick handler
--end)
script.on_event(defines.events.on_player_driving_changed_state, 
function(event)
    p=game.players[event.player_index];
    if not p.driving then
        global.active=true
        global.players[#global.players+1]={p,event.tick+1}
    end
end)

script.on_event(defines.events.on_tick,
function(event)
    if global.active then
        local ps=global.players
        for i=#ps,1,-1 do
            if event.tick==ps[i][2] and ps[i][1].walking_state.walking then
                pos=moveposition(ps[i][1].position, ps[i][1].walking_state.direction, 3.5)
                --we don't want to put player into stone, do we?
                pos=ps[i][1].surface.find_non_colliding_position("player",pos,.5,.5)
                if pos then 
                    ps[i][1].teleport(pos) 
                else--if it fails to put player in that direction player may accidentally run under the train
                    pos=moveposition(ps[i][1].position,util.oppositedirection(ps[i][1].walking_state.direction), 3.5)
                    pos=ps[i][1].surface.find_non_colliding_position("player",pos,.5,.5)
                    if pos then
                        ps[i][1].teleport(pos)
                    else--if it fails that
                    end
                end
                table.remove(ps,i)
            end
        end
        if #ps==0 then global.active=false end
    end
end)
--tweaked util function
function moveposition(position, direction, distance)
  if direction == defines.direction.north then
    return {x=position.x, y=position.y - distance}
  end

  if direction == defines.direction.south then
    return {x=position.x, y=position.y + distance}
  end

  if direction == defines.direction.east then
    return {x=position.x + distance, y=position.y}
  end

  if direction == defines.direction.west then
    return {x=position.x - distance, y=position.y}
  end
end
